---
stages:
  - lint
  - build
  - test

.docker-build:
  image: registry.gitlab.com/orange-opensource/lfn/infra/containers/buildah
  stage: build
  before_script:
    - export STORAGE_DRIVER=vfs
    - export BUILDAH_FORMAT=docker
    - export REGISTRY_AUTH_FILE=${HOME}/auth.json
    - |
      echo "$CI_REGISTRY_PASSWORD" |
      buildah login -u "$CI_REGISTRY_USER" --password-stdin $CI_REGISTRY
  script:
    - git clone --depth 1 ${CHAINEDCI_TOOLS_GIT} ${CHAINEDCI_TOOLS_DST}
    - export BUILD_DATE=$(date -u +"%Y-%m-%dT%H:%M:%SZ")
    - >
      buildah bud -f "${DOCKERFILE}" \
        --build-arg VCS_REF="${CI_COMMIT_SHORT_SHA}" \
        --build-arg BUILD_DATE="${BUILD_DATE}" \
        -t "${DOCKER_IMAGE}" .
    - buildah push "${DOCKER_IMAGE}"

docker-build-master:
  # Official docker image.
  variables:
    DOCKER_IMAGE: "${CI_REGISTRY_IMAGE}"
    DOCKERFILE: Dockerfile
  extends: .docker-build
  rules:
    - if: $CI_MERGE_REQUEST_ID
      when: never
    - if: $CI_COMMIT_BRANCH == "master"

docker-build-master-alpine:
  # Official docker image.
  extends: .docker-build
  variables:
    DOCKER_IMAGE: "${CI_REGISTRY_IMAGE}:alpine"
    DOCKERFILE: Dockerfile_alpine
  rules:
    - if: $CI_MERGE_REQUEST_ID
      when: never
    - if: $CI_COMMIT_BRANCH == "master" && $BUILD_ALPINE_ENABLED

docker-build:
  # Official docker image.
  extends: .docker-build
  variables:
    DOCKER_IMAGE: "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG"
    DOCKERFILE: Dockerfile
  rules:
    - if: $CI_MERGE_REQUEST_ID
      when: never
    - if: $CI_COMMIT_BRANCH != "master"

docker-build-alpine:
  # Official docker image.
  extends: .docker-build
  variables:
    DOCKER_IMAGE: "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG-alpine"
    DOCKERFILE: Dockerfile_alpine
  rules:
    - if: $CI_MERGE_REQUEST_ID
      when: never
    - if: $CI_COMMIT_BRANCH != "master" && $BUILD_ALPINE_ENABLED

# yamllint disable rule:line-length
include:
  - remote: 'https://gitlab.com/Orange-OpenSource/lfn/ci_cd/gitlab-ci-templates/-/raw/master/Container-Scanning.gitlab-ci.yml'
